/*** SP.C ***/

#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

/* #define VETOR_DE_NOS */

#define  ESC            27
#define  SetaPCima      72
#define  SetaPBaixo     80
#define  SetaPEsquerda  75
#define  SetaPDireita   77
#define  TeclaF1        59
#define  TeclaF2        60
#define  TeclaF3        61
#define  TeclaF4        62
#define  TeclaF5        63
#define  TeclaF6        64
#define  TeclaF7        65
#define  TeclaF8        66
#define  TeclaF9        67
#define  TeclaF10       68
#define  TeclaF11       133
#define  TeclaF12       134
#define  AltF1          104

extern unsigned _stklen = 20000;

#define MAX_NOS 100
float X[MAX_NOS];

#include "pintar.c"
#include "mouse.c"
typedef struct { float x, y; } ponto;
ponto P[100];
int n = 9, I, k = 3, A, B, TAM;

/* ---------------------------------------------------------------------- */

void IniciaModoGrafico(void) {

  /* Coloca a tela no modo grafico */

  int DriverGrafico, ModoGrafico;
  registerbgidriver(EGAVGA_driver);
  DriverGrafico = DETECT;
  initgraph(&DriverGrafico, &ModoGrafico, "");
  if (graphresult() < 0) {
    printf("\nERRO na mudanca para o modo grafico.\n");
    exit(1);
  }
}

/* ---------------------------------------------------------------------- */

void DesenhaGraficoParam(float (*f)(float), float (*g)(float),
		    float tmin, float tmax) {

/* Desenha o grafico plano definido parametricamente por (f(t), g(t)). */

  float t, inc = 0.02;

  inc = (tmax - tmin)/100.0;
  setcolor(CYAN);
  for (t = tmin; t <= tmax - inc; t += inc) {
    line((int) (A + f(t)*TAM), (int) (B - g(t)*TAM),
	 (int) (A + f(t + inc)*TAM), (int) (B - g(t + inc)*TAM));
  }
  while (t < tmax) {
    putpixel((int) (A + f(t)*TAM), (int) (B - g(t)*TAM), CYAN);
    t += 0.001;
  }
}

/* ---------------------------------------------------------------------- */

void  VetorDeNosUniforme(int k, int n, float X[]) {

  int i;

  for (i = 1; i <= k; i++) X[i] = 0.0;
  for (i = k + 1; i <= n + 1; i++) X[i] = ((float) (i - k))/(n - k + 2.0);
  for (i = n + 2; i <= n + k + 1; i++) X[i] = 1.0;
}

/* ---------------------------------------------------------------------- */

float N(float x[], int i, int k, float t) {

/* B-spline N(i, k, t). Devem ter sido definido antes os ns x[j] com
   1  j  i + k + 1   e   x[j]  x[j + 1]  para todo j */

  float soma = 0;

  if (k == 1) {
    if (x[i] <= t && t < x[i + 1])
      return 1;
    else
      return 0;
  }

  if (k > 1) {
    if (x[i + k - 1] != x[i] && t != x[i])
      soma += (t - x[i])/(x[i + k - 1] - x[i])*N(x, i, k - 1, t);
    if (x[i + k] != x[i + 1] && t != x[i + k])
      soma += (x[i + k] - t)/(x[i + k] - x[i + 1])*N(x, i + 1, k - 1, t);
  }
  return soma;
}

/* ---------------------------------------------------------------------- */

float Px(float t) {

  float soma = 0;
  int i;

  for (i = 1; i <= n + 1; i++) soma += P[i].x*N(X, i, k, t);
  return soma;
}

/* ---------------------------------------------------------------------- */

float Py(float t) {

  float soma = 0;
  int i;

  for (i = 1; i <= n + 1; i++) soma += P[i].y*N(X, i, k, t);
  return soma;
}

/* ---------------------------------------------------------------------- */

void PontoDeControle(int j) {

/* Desenha o j-esimo ponto de controle */

  putpixel(A + P[j].x*TAM, B - P[j].y*TAM, YELLOW);
  putpixel(A + P[j].x*TAM + 1, B - P[j].y*TAM + 1, YELLOW);
  putpixel(A + P[j].x*TAM + 1, B - P[j].y*TAM - 1, YELLOW);
  putpixel(A + P[j].x*TAM - 1, B - P[j].y*TAM + 1, YELLOW);
  putpixel(A + P[j].x*TAM - 1, B - P[j].y*TAM - 1, YELLOW);
  putpixel(A + P[j].x*TAM + 2, B - P[j].y*TAM + 2, YELLOW);
  putpixel(A + P[j].x*TAM + 2, B - P[j].y*TAM - 2, YELLOW);
  putpixel(A + P[j].x*TAM - 2, B - P[j].y*TAM + 2, YELLOW);
  putpixel(A + P[j].x*TAM - 2, B - P[j].y*TAM - 2, YELLOW);
}

/* ---------------------------------------------------------------------- */

void ConvexHull(void) {

/* Desenha uma uniao de triangulos que contem a curva B-spline quadratica */

  int L;

  for (L = 1; L <= n - 1; L++)
    Pintar(A+P[L].x*TAM, B-P[L].y*TAM, A+P[L+1].x*TAM, B-P[L+1].y*TAM,
	   A+P[L+2].x*TAM, B-P[L+2].y*TAM, DARKGRAY, DARKGRAY, BLACK, 85);
}

/* ---------------------------------------------------------------------- */

void main(void) {

  int vez = 0, i, pos_x, pos_y;
  float tmin, tmax;
  unsigned char ch;
  int fecho = 0, j = 0;

  mouse = HaSuporteAoMouse();
  if (!mouse) {
    printf("\n\aNao ha' suporte ao mouse. Use o programa _SP.EXE.");
    return;
  }
  printf("\nValor de k? (Sugestao: k = 3) ---> k = "); scanf("%d", &k);
  if (k < 2 || k > 10) k = 3;

  if (k == 3)
    printf("\n\n*** B-SPLINES QUADRATICOS ***\n");
  else if (k == 4)
    printf("\n\n*** B-SPLINES CUBICOS ***\n");
  else
    printf("\n\n*** B-SPLINES (k = %d) ***\n", k);

  printf("\nQuantidade de pontos de controle? (de 3 a 12) ");
  scanf("%d", &n);
  if (n < 3 || n > 12) n = 10;
  n--;

  VetorDeNosUniforme(k, n, X);

  #ifdef VETOR_DE_NOS
    printf("\n\nSer usado um vetor de ns uniforme: \n\n(  ");
    for (i = 1; i <= n + k + 1; i++) printf("%4.2f  ", X[i]);
    printf(")\n\n");
  #else
    printf("\n\nSer usado um vetor de ns uniforme\n\n");
  #endif

  printf("\n%c ESC: encerra o programa", 254);
  if (k == 3)
    printf("\n%c Alt-F1: mostra (ou esconde) uma uniao de tringulos que "
	   "contm a curva", 254);
  if (mouse)
    printf("\n%c Botao esquerdo do mouse: determina os pontos de controle",254);
  printf("\n%c Fn: marca (ou desmarca) o n-simo ponto de controle", 254);
  printf("\n%c Teclas de setas: movem o ponto de controle marcado", 254);
  printf("\n\nPressione qualquer tecla para continuar");
  getch();

  P[1].x = 0; P[1].y = 2;
  P[2].x = 1; P[2].y = 4;
  P[3].x = 2; P[3].y = 3;
  P[4].x = 0; P[4].y = -1;
  P[5].x = 4; P[5].y = 0;
  P[6].x = 5; P[6].y = -1;
  P[7].x = 6; P[7].y = 4;
  P[8].x = 7; P[8].y = -1;
  P[9].x = 8; P[9].y = 0;
  P[10].x = 9; P[10].y = -1;
  P[11].x = 10; P[11].y = 4;
  P[12].x = 8; P[12].y = 4;

  IniciaModoGrafico();
  A = getmaxx()/10; B = getmaxy()/2; TAM = 50;
  setcolor(DARKGRAY);
  line(0, B, getmaxx(), B);
  line(A, 0, A, getmaxy());
  if (mouse) {
    i = 0;
    AjustaLimitesVerticais(0, getmaxy());
    AjustaLimitesHorizontais(0, getmaxx());
    AjustaPosicaoDoMouse(getmaxx()/2, getmaxy()/2);
    AjustaFormaDoIndicadorGrafico(X_GLOVE, Y_GLOVE, (long) Glove);
    MostraMouse();
    do {
      while (PosicaoDoMouse(&pos_x, &pos_y) != BOTAO_ESQUERDO);
      i++;
      P[i].x = (pos_x - (float) A)/((float) TAM);
      P[i].y = ((float) B - pos_y)/((float) TAM);
      EscondeMouse();
      PontoDeControle(i);
      MostraMouse();
      delay(800);
    } while (i <= n);
    EscondeMouse();
  }
  j = 1;
  cleardevice();
  do {
  if (fecho) ConvexHull();
  setcolor(DARKGRAY);
  line(0, B, getmaxx(), B);
  line(A, 0, A, getmaxy());
  if (j) PontoDeControle(j);
  setcolor(RED);
  setlinestyle(USERBIT_LINE, 34952U, NORM_WIDTH);
  for (i = 1; i <= n; i++)
    line(A+P[i].x*TAM, B-P[i].y*TAM, A+P[i + 1].x*TAM, B-P[i + 1].y*TAM);
  setlinestyle(SOLID_LINE, 0, NORM_WIDTH);
  tmin = 0.0;
  tmax = 1.0;
  DesenhaGraficoParam(Px, Py, tmin, tmax);
  if (++vez == 1)
    outtextxy(0, getmaxy() - 10,
    "Fn: escolhem ponto de controle   "
    "Setas: movem ponto de controle   ESC: encerra");

  ch = getch();
    if (ch == 0) {
      ch = getch();

      switch (ch) {
	case TeclaF1: if (j != 1 && n + 1 >= 1) j = 1; else j = 0; break;
	case TeclaF2: if (j != 2 && n + 1 >= 2) j = 2; else j = 0; break;
	case TeclaF3: if (j != 3 && n + 1 >= 3) j = 3; else j = 0; break;
	case TeclaF4: if (j != 4 && n + 1 >= 4) j = 4; else j = 0; break;
	case TeclaF5: if (j != 5 && n + 1 >= 5) j = 5; else j = 0; break;
	case TeclaF6: if (j != 6 && n + 1 >= 6) j = 6; else j = 0; break;
	case TeclaF7: if (j != 7 && n + 1 >= 7) j = 7; else j = 0; break;
	case TeclaF8: if (j != 8 && n + 1 >= 8) j = 8; else j = 0; break;
	case TeclaF9: if (j != 9 && n + 1 >= 9) j = 9; else j = 0; break;
	case TeclaF10: if (j != 10 && n + 1 >= 10) j = 10; else j = 0; break;
	case TeclaF11: if (j != 11 && n + 1 >= 11) j = 11; else j = 0; break;
	case TeclaF12: if (j != 12 && n + 1 >= 12) j = 12; else j = 0; break;
	case AltF1: if (k == 3) fecho ^= 1;
	case SetaPCima: if (j) P[j].y += 0.5; break;
	case SetaPBaixo: if (j) P[j].y -= 0.5; break;
	case SetaPEsquerda: if (j) P[j].x -= 0.5; break;
	case SetaPDireita: if (j) P[j].x += 0.5; break;
      }

    }
    cleardevice();
  } while (ch != ESC);

  closegraph();
}

/* ----------------------------------------------------------------------- */

/*** FIM DE SP.C ***/